diff --git a/Documentation/hid/hid-sensor.rst b/Documentation/hid/hid-sensor.rst
index c1c9b8d8dca6..b98d7a415cda 100644
--- a/Documentation/hid/hid-sensor.rst
+++ b/Documentation/hid/hid-sensor.rst
@@ -173,39 +173,39 @@ An example of this representation on sysfs::
 
   /sys/devices/pci0000:00/INT33C2:00/i2c-0/i2c-INT33D1:00/0018:8086:09FA.0001/HID-SENSOR-2000e1.6.auto$ tree -R
   .
-  │   ├──  enable_sensor
-  │   │   ├── feature-0-200316
-  │   │   │   ├── feature-0-200316-maximum
-  │   │   │   ├── feature-0-200316-minimum
-  │   │   │   ├── feature-0-200316-name
-  │   │   │   ├── feature-0-200316-size
-  │   │   │   ├── feature-0-200316-unit-expo
-  │   │   │   ├── feature-0-200316-units
-  │   │   │   ├── feature-0-200316-value
-  │   │   ├── feature-1-200201
-  │   │   │   ├── feature-1-200201-maximum
-  │   │   │   ├── feature-1-200201-minimum
-  │   │   │   ├── feature-1-200201-name
-  │   │   │   ├── feature-1-200201-size
-  │   │   │   ├── feature-1-200201-unit-expo
-  │   │   │   ├── feature-1-200201-units
-  │   │   │   ├── feature-1-200201-value
-  │   │   ├── input-0-200201
-  │   │   │   ├── input-0-200201-maximum
-  │   │   │   ├── input-0-200201-minimum
-  │   │   │   ├── input-0-200201-name
-  │   │   │   ├── input-0-200201-size
-  │   │   │   ├── input-0-200201-unit-expo
-  │   │   │   ├── input-0-200201-units
-  │   │   │   ├── input-0-200201-value
-  │   │   ├── input-1-200202
-  │   │   │   ├── input-1-200202-maximum
-  │   │   │   ├── input-1-200202-minimum
-  │   │   │   ├── input-1-200202-name
-  │   │   │   ├── input-1-200202-size
-  │   │   │   ├── input-1-200202-unit-expo
-  │   │   │   ├── input-1-200202-units
-  │   │   │   ├── input-1-200202-value
+  │   ├──  enable_sensor
+  │   │   ├── feature-0-200316
+  │   │   │   ├── feature-0-200316-maximum
+  │   │   │   ├── feature-0-200316-minimum
+  │   │   │   ├── feature-0-200316-name
+  │   │   │   ├── feature-0-200316-size
+  │   │   │   ├── feature-0-200316-unit-expo
+  │   │   │   ├── feature-0-200316-units
+  │   │   │   ├── feature-0-200316-value
+  │   │   ├── feature-1-200201
+  │   │   │   ├── feature-1-200201-maximum
+  │   │   │   ├── feature-1-200201-minimum
+  │   │   │   ├── feature-1-200201-name
+  │   │   │   ├── feature-1-200201-size
+  │   │   │   ├── feature-1-200201-unit-expo
+  │   │   │   ├── feature-1-200201-units
+  │   │   │   ├── feature-1-200201-value
+  │   │   ├── input-0-200201
+  │   │   │   ├── input-0-200201-maximum
+  │   │   │   ├── input-0-200201-minimum
+  │   │   │   ├── input-0-200201-name
+  │   │   │   ├── input-0-200201-size
+  │   │   │   ├── input-0-200201-unit-expo
+  │   │   │   ├── input-0-200201-units
+  │   │   │   ├── input-0-200201-value
+  │   │   ├── input-1-200202
+  │   │   │   ├── input-1-200202-maximum
+  │   │   │   ├── input-1-200202-minimum
+  │   │   │   ├── input-1-200202-name
+  │   │   │   ├── input-1-200202-size
+  │   │   │   ├── input-1-200202-unit-expo
+  │   │   │   ├── input-1-200202-units
+  │   │   │   ├── input-1-200202-value
 
 Here there is a custom sensor with four fields: two feature and two inputs.
 Each field is represented by a set of attributes. All fields except the "value"
@@ -234,8 +234,8 @@ Once enabled and powered on, sensor can report value using HID reports.
 These reports are pushed using misc device interface in a FIFO order::
 
 	/dev$ tree | grep HID-SENSOR-2000e1.6.auto
-	│   │   │   ├── 10:53 -> ../HID-SENSOR-2000e1.6.auto
-	│   ├──  HID-SENSOR-2000e1.6.auto
+	│   │   │   ├── 10:53 -> ../HID-SENSOR-2000e1.6.auto
+	│   ├──  HID-SENSOR-2000e1.6.auto
 
 Each report can be of variable length preceded by a header. This header
 consists of a 32-bit usage id, 64-bit time stamp and 32-bit length field of raw
diff --git a/Documentation/hid/intel-ish-hid.rst b/Documentation/hid/intel-ish-hid.rst
index 7a851252267a..a525cdefc937 100644
--- a/Documentation/hid/intel-ish-hid.rst
+++ b/Documentation/hid/intel-ish-hid.rst
@@ -355,133 +355,133 @@ To debug ISH, event tracing mechanism is used. To enable debug logs::
   root@otcpl-ThinkPad-Yoga-260:~# tree -l /sys/bus/iio/devices/
   /sys/bus/iio/devices/
   ├── iio:device0 -> ../../../devices/0044:8086:22D8.0001/HID-SENSOR-200073.9.auto/iio:device0
-  │   ├── buffer
-  │   │   ├── enable
-  │   │   ├── length
-  │   │   └── watermark
+  │   ├── buffer
+  │   │   ├── enable
+  │   │   ├── length
+  │   │   └── watermark
   ...
-  │   ├── in_accel_hysteresis
-  │   ├── in_accel_offset
-  │   ├── in_accel_sampling_frequency
-  │   ├── in_accel_scale
-  │   ├── in_accel_x_raw
-  │   ├── in_accel_y_raw
-  │   ├── in_accel_z_raw
-  │   ├── name
-  │   ├── scan_elements
-  │   │   ├── in_accel_x_en
-  │   │   ├── in_accel_x_index
-  │   │   ├── in_accel_x_type
-  │   │   ├── in_accel_y_en
-  │   │   ├── in_accel_y_index
-  │   │   ├── in_accel_y_type
-  │   │   ├── in_accel_z_en
-  │   │   ├── in_accel_z_index
-  │   │   └── in_accel_z_type
+  │   ├── in_accel_hysteresis
+  │   ├── in_accel_offset
+  │   ├── in_accel_sampling_frequency
+  │   ├── in_accel_scale
+  │   ├── in_accel_x_raw
+  │   ├── in_accel_y_raw
+  │   ├── in_accel_z_raw
+  │   ├── name
+  │   ├── scan_elements
+  │   │   ├── in_accel_x_en
+  │   │   ├── in_accel_x_index
+  │   │   ├── in_accel_x_type
+  │   │   ├── in_accel_y_en
+  │   │   ├── in_accel_y_index
+  │   │   ├── in_accel_y_type
+  │   │   ├── in_accel_z_en
+  │   │   ├── in_accel_z_index
+  │   │   └── in_accel_z_type
   ...
-  │   │   ├── devices
-  │   │   │   │   ├── buffer
-  │   │   │   │   │   ├── enable
-  │   │   │   │   │   ├── length
-  │   │   │   │   │   └── watermark
-  │   │   │   │   ├── dev
-  │   │   │   │   ├── in_intensity_both_raw
-  │   │   │   │   ├── in_intensity_hysteresis
-  │   │   │   │   ├── in_intensity_offset
-  │   │   │   │   ├── in_intensity_sampling_frequency
-  │   │   │   │   ├── in_intensity_scale
-  │   │   │   │   ├── name
-  │   │   │   │   ├── scan_elements
-  │   │   │   │   │   ├── in_intensity_both_en
-  │   │   │   │   │   ├── in_intensity_both_index
-  │   │   │   │   │   └── in_intensity_both_type
-  │   │   │   │   ├── trigger
-  │   │   │   │   │   └── current_trigger
+  │   │   ├── devices
+  │   │   │   │   ├── buffer
+  │   │   │   │   │   ├── enable
+  │   │   │   │   │   ├── length
+  │   │   │   │   │   └── watermark
+  │   │   │   │   ├── dev
+  │   │   │   │   ├── in_intensity_both_raw
+  │   │   │   │   ├── in_intensity_hysteresis
+  │   │   │   │   ├── in_intensity_offset
+  │   │   │   │   ├── in_intensity_sampling_frequency
+  │   │   │   │   ├── in_intensity_scale
+  │   │   │   │   ├── name
+  │   │   │   │   ├── scan_elements
+  │   │   │   │   │   ├── in_intensity_both_en
+  │   │   │   │   │   ├── in_intensity_both_index
+  │   │   │   │   │   └── in_intensity_both_type
+  │   │   │   │   ├── trigger
+  │   │   │   │   │   └── current_trigger
   ...
-  │   │   │   │   ├── buffer
-  │   │   │   │   │   ├── enable
-  │   │   │   │   │   ├── length
-  │   │   │   │   │   └── watermark
-  │   │   │   │   ├── dev
-  │   │   │   │   ├── in_magn_hysteresis
-  │   │   │   │   ├── in_magn_offset
-  │   │   │   │   ├── in_magn_sampling_frequency
-  │   │   │   │   ├── in_magn_scale
-  │   │   │   │   ├── in_magn_x_raw
-  │   │   │   │   ├── in_magn_y_raw
-  │   │   │   │   ├── in_magn_z_raw
-  │   │   │   │   ├── in_rot_from_north_magnetic_tilt_comp_raw
-  │   │   │   │   ├── in_rot_hysteresis
-  │   │   │   │   ├── in_rot_offset
-  │   │   │   │   ├── in_rot_sampling_frequency
-  │   │   │   │   ├── in_rot_scale
-  │   │   │   │   ├── name
+  │   │   │   │   ├── buffer
+  │   │   │   │   │   ├── enable
+  │   │   │   │   │   ├── length
+  │   │   │   │   │   └── watermark
+  │   │   │   │   ├── dev
+  │   │   │   │   ├── in_magn_hysteresis
+  │   │   │   │   ├── in_magn_offset
+  │   │   │   │   ├── in_magn_sampling_frequency
+  │   │   │   │   ├── in_magn_scale
+  │   │   │   │   ├── in_magn_x_raw
+  │   │   │   │   ├── in_magn_y_raw
+  │   │   │   │   ├── in_magn_z_raw
+  │   │   │   │   ├── in_rot_from_north_magnetic_tilt_comp_raw
+  │   │   │   │   ├── in_rot_hysteresis
+  │   │   │   │   ├── in_rot_offset
+  │   │   │   │   ├── in_rot_sampling_frequency
+  │   │   │   │   ├── in_rot_scale
+  │   │   │   │   ├── name
   ...
-  │   │   │   │   ├── scan_elements
-  │   │   │   │   │   ├── in_magn_x_en
-  │   │   │   │   │   ├── in_magn_x_index
-  │   │   │   │   │   ├── in_magn_x_type
-  │   │   │   │   │   ├── in_magn_y_en
-  │   │   │   │   │   ├── in_magn_y_index
-  │   │   │   │   │   ├── in_magn_y_type
-  │   │   │   │   │   ├── in_magn_z_en
-  │   │   │   │   │   ├── in_magn_z_index
-  │   │   │   │   │   ├── in_magn_z_type
-  │   │   │   │   │   ├── in_rot_from_north_magnetic_tilt_comp_en
-  │   │   │   │   │   ├── in_rot_from_north_magnetic_tilt_comp_index
-  │   │   │   │   │   └── in_rot_from_north_magnetic_tilt_comp_type
-  │   │   │   │   ├── trigger
-  │   │   │   │   │   └── current_trigger
+  │   │   │   │   ├── scan_elements
+  │   │   │   │   │   ├── in_magn_x_en
+  │   │   │   │   │   ├── in_magn_x_index
+  │   │   │   │   │   ├── in_magn_x_type
+  │   │   │   │   │   ├── in_magn_y_en
+  │   │   │   │   │   ├── in_magn_y_index
+  │   │   │   │   │   ├── in_magn_y_type
+  │   │   │   │   │   ├── in_magn_z_en
+  │   │   │   │   │   ├── in_magn_z_index
+  │   │   │   │   │   ├── in_magn_z_type
+  │   │   │   │   │   ├── in_rot_from_north_magnetic_tilt_comp_en
+  │   │   │   │   │   ├── in_rot_from_north_magnetic_tilt_comp_index
+  │   │   │   │   │   └── in_rot_from_north_magnetic_tilt_comp_type
+  │   │   │   │   ├── trigger
+  │   │   │   │   │   └── current_trigger
   ...
-  │   │   │   │   ├── buffer
-  │   │   │   │   │   ├── enable
-  │   │   │   │   │   ├── length
-  │   │   │   │   │   └── watermark
-  │   │   │   │   ├── dev
-  │   │   │   │   ├── in_anglvel_hysteresis
-  │   │   │   │   ├── in_anglvel_offset
-  │   │   │   │   ├── in_anglvel_sampling_frequency
-  │   │   │   │   ├── in_anglvel_scale
-  │   │   │   │   ├── in_anglvel_x_raw
-  │   │   │   │   ├── in_anglvel_y_raw
-  │   │   │   │   ├── in_anglvel_z_raw
-  │   │   │   │   ├── name
-  │   │   │   │   ├── scan_elements
-  │   │   │   │   │   ├── in_anglvel_x_en
-  │   │   │   │   │   ├── in_anglvel_x_index
-  │   │   │   │   │   ├── in_anglvel_x_type
-  │   │   │   │   │   ├── in_anglvel_y_en
-  │   │   │   │   │   ├── in_anglvel_y_index
-  │   │   │   │   │   ├── in_anglvel_y_type
-  │   │   │   │   │   ├── in_anglvel_z_en
-  │   │   │   │   │   ├── in_anglvel_z_index
-  │   │   │   │   │   └── in_anglvel_z_type
-  │   │   │   │   ├── trigger
-  │   │   │   │   │   └── current_trigger
+  │   │   │   │   ├── buffer
+  │   │   │   │   │   ├── enable
+  │   │   │   │   │   ├── length
+  │   │   │   │   │   └── watermark
+  │   │   │   │   ├── dev
+  │   │   │   │   ├── in_anglvel_hysteresis
+  │   │   │   │   ├── in_anglvel_offset
+  │   │   │   │   ├── in_anglvel_sampling_frequency
+  │   │   │   │   ├── in_anglvel_scale
+  │   │   │   │   ├── in_anglvel_x_raw
+  │   │   │   │   ├── in_anglvel_y_raw
+  │   │   │   │   ├── in_anglvel_z_raw
+  │   │   │   │   ├── name
+  │   │   │   │   ├── scan_elements
+  │   │   │   │   │   ├── in_anglvel_x_en
+  │   │   │   │   │   ├── in_anglvel_x_index
+  │   │   │   │   │   ├── in_anglvel_x_type
+  │   │   │   │   │   ├── in_anglvel_y_en
+  │   │   │   │   │   ├── in_anglvel_y_index
+  │   │   │   │   │   ├── in_anglvel_y_type
+  │   │   │   │   │   ├── in_anglvel_z_en
+  │   │   │   │   │   ├── in_anglvel_z_index
+  │   │   │   │   │   └── in_anglvel_z_type
+  │   │   │   │   ├── trigger
+  │   │   │   │   │   └── current_trigger
   ...
-  │   │   │   │   ├── buffer
-  │   │   │   │   │   ├── enable
-  │   │   │   │   │   ├── length
-  │   │   │   │   │   └── watermark
-  │   │   │   │   ├── dev
-  │   │   │   │   ├── in_anglvel_hysteresis
-  │   │   │   │   ├── in_anglvel_offset
-  │   │   │   │   ├── in_anglvel_sampling_frequency
-  │   │   │   │   ├── in_anglvel_scale
-  │   │   │   │   ├── in_anglvel_x_raw
-  │   │   │   │   ├── in_anglvel_y_raw
-  │   │   │   │   ├── in_anglvel_z_raw
-  │   │   │   │   ├── name
-  │   │   │   │   ├── scan_elements
-  │   │   │   │   │   ├── in_anglvel_x_en
-  │   │   │   │   │   ├── in_anglvel_x_index
-  │   │   │   │   │   ├── in_anglvel_x_type
-  │   │   │   │   │   ├── in_anglvel_y_en
-  │   │   │   │   │   ├── in_anglvel_y_index
-  │   │   │   │   │   ├── in_anglvel_y_type
-  │   │   │   │   │   ├── in_anglvel_z_en
-  │   │   │   │   │   ├── in_anglvel_z_index
-  │   │   │   │   │   └── in_anglvel_z_type
-  │   │   │   │   ├── trigger
-  │   │   │   │   │   └── current_trigger
+  │   │   │   │   ├── buffer
+  │   │   │   │   │   ├── enable
+  │   │   │   │   │   ├── length
+  │   │   │   │   │   └── watermark
+  │   │   │   │   ├── dev
+  │   │   │   │   ├── in_anglvel_hysteresis
+  │   │   │   │   ├── in_anglvel_offset
+  │   │   │   │   ├── in_anglvel_sampling_frequency
+  │   │   │   │   ├── in_anglvel_scale
+  │   │   │   │   ├── in_anglvel_x_raw
+  │   │   │   │   ├── in_anglvel_y_raw
+  │   │   │   │   ├── in_anglvel_z_raw
+  │   │   │   │   ├── name
+  │   │   │   │   ├── scan_elements
+  │   │   │   │   │   ├── in_anglvel_x_en
+  │   │   │   │   │   ├── in_anglvel_x_index
+  │   │   │   │   │   ├── in_anglvel_x_type
+  │   │   │   │   │   ├── in_anglvel_y_en
+  │   │   │   │   │   ├── in_anglvel_y_index
+  │   │   │   │   │   ├── in_anglvel_y_type
+  │   │   │   │   │   ├── in_anglvel_z_en
+  │   │   │   │   │   ├── in_anglvel_z_index
+  │   │   │   │   │   └── in_anglvel_z_type
+  │   │   │   │   ├── trigger
+  │   │   │   │   │   └── current_trigger
   ...